Camera = Core.class(Sprite)

local rasterHeight, rasterWidth, worldWidth, worldHeight, target, container, zoomLevel
local layers = {}


function Camera:init(ww, wh)

rasterWidth = application:getContentWidth()
rasterHeight = application:getContentHeight()
worldWidth = ww
worldHeight = wh

zoomLevel = 1
print("Camera init.  Raster Size: ".. rasterWidth .."x".. rasterHeight .." World size: ".. worldWidth .."x".. worldHeight)

	

end

function Camera:track(ct)
target = ct
container = target:getParent()

end

function Camera:addLayer(layerTable)
--print("Added Layer ".. layername .." Depth ".. depth)
	
	
	table.insert(layers, layerTable)
	print("Layer added, Number Layers ".. #layers)
	
end



function Camera:lookAt( )

local bgOffsetX, offsetX, offsetY = getCurrentOffset()

for i = 1, #layers do
	for i,v in pairs(layers) do 
		if(v[2] ~= 1) then -- Background or Foreground
			v[1]:setPosition(bgOffsetX * v[2],  worldHeight - 760 + offsetY )
		elseif(v[2] == 1) then -- Level
			v[1]:setPosition(offsetX * v[2],  offsetY)
		end
	end
end

--layers[1]:setPosition(bgOffsetX/2.1, worldHeight - 760 + offsetY)
--layers[2]:setPosition(bgOffsetX*2, worldHeight - 860 + offsetY)
--layers[3]:setPosition(offsetX , offsetY)



end


function getWorldPoint(rasterX, rasterY)

-- For Scale we need to new co ordinates to center on as after scaling the width and height of the container changes.
-- Width * Zoom Ratio = New Width
end



function getCurrentOffset()
local offsetX, offsetY = 0,0
local bgOffsetX, bgOffsetY = 0,0
--print("X ".. target:getX())
	if( (worldWidth - target:getX()) < rasterWidth/2) then
		offsetX = -worldWidth + rasterWidth
		bgOffsetX = -worldWidth + rasterWidth
	elseif(target:getX() >= rasterWidth/2) then		
		offsetX = -(target:getX() - rasterWidth/2)
		bgOffsetX = -(target:getX() - rasterWidth/2)
	elseif(target:getX() < rasterWidth/2) then
		bgOffsetX = - (target:getX() - rasterWidth/2)
		
	end


	
	if( (worldHeight - target:getY()) < rasterHeight/2) then
		offsetY = -worldHeight + rasterHeight
	elseif( target:getY() >= rasterHeight/2) then
		offsetY = -(target:getY() - rasterHeight/2) 
	elseif(target:getY() < rasterHeight/2) then	
		--offsetY = -target:getY()/2
	end


--print("X ".. container:getX() .."	Y ".. container:getY() .."	W ".. container:getWidth() .."	H ".. container:getHeight() )

return bgOffsetX, offsetX, offsetY

end


function Camera:getZoom()
 return zoomLevel;
end


function Camera:setZoom(zoomLevel)
	if(zoomLevel <= 0) then
	 zoomLevel =  1
	elseif(zoomLevel >= 2) then
		zoomLevel = 2
	end
	
--	local wcx, wcy = getWorldPoint(rasterWidth/2, rasterHeight/2)
	container:setScale(zoomLevel)
	pixelAdjustment = zoomLevel * 1
	
	self:lookAt(target:getX(), target:getY())
	 

end
