-- Left & Right And Jump controls
controls = Core.class(Sprite)


-- Move Our Guy !
local function onClick(but)

	if(but == "lb") then
		print("Left Pressed")
		Player:setDirection(-1,0)
	elseif(but == "rb") then
		print("Right Pressed")
		Player:setDirection(1,0)
	end
	
	if(but == "jb") then
		print("Jump Pressed")
		Player:setDirection(0, -1)
	end

end

local function offClick(but)
Player:setDirection(0,0)
end





function controls:init(startXPos, startYPos)
print("Controls:init")

local btntexture = Texture.new("images/navigation.png")

local leftButtonDownTexture = Bitmap.new(TextureRegion.new(btntexture,133,1,130,130))
local rightButtonDownTexture = Bitmap.new(TextureRegion.new(btntexture,1,133,130,130))

local leftButtonUpTexture = Bitmap.new(TextureRegion.new(btntexture,1,363,130,130))
local rightButtonUpTexture = Bitmap.new(TextureRegion.new(btntexture,1,1,130,130))

local jumpButtonDownTexture = Bitmap.new(TextureRegion.new(btntexture,265,1,130,130))
local jumpButtonUpTexture = Bitmap.new(TextureRegion.new(btntexture,133,133,130,130))

local leftButton = Button.new(leftButtonDownTexture, leftButtonUpTexture)
local rightButton = Button.new(rightButtonDownTexture, rightButtonUpTexture)
local jumpButton = Button.new(jumpButtonDownTexture, jumpButtonUpTexture)

leftButton:setPosition(0,0)
rightButton:setPosition(150,0)
jumpButton:setPosition(appHeight - 250 , 0)

leftButton.name = "lb"
rightButton.name = "rb"
jumpButton.name = "jb"


self:addChild(leftButton)
self:addChild(rightButton)
self:addChild(jumpButton)
self:setPosition(startXPos, startYPos)


-- Listeners

leftButton:addEventListener("click", onClick, leftButton.name)
rightButton:addEventListener("click", onClick, rightButton.name)
jumpButton:addEventListener("click", onClick, jumpButton.name)

leftButton:addEventListener("offclick", offClick, leftButton.name)
rightButton:addEventListener("offclick", offClick, rightButton.name)
jumpButton:addEventListener("offclick", offClick, jumpButton.name)

return controls

end



